import turtle
import TurtleUtilsPMP as tp


def main():
    scr = tp.initializescreen()
    t1 = tp.initializeturtle()
    t1.ht()
    polygons(t1)
    writetest(t1, scr)
    scr.exitonclick()


def polygons(t):
    t.pensize(4)
    s = 150
    tp.circle(t, s+280, 'black', 'light gray', True, True)
    cols = ['cyan', 'blue', 'magenta', 'green', 'light green', 'maroon', \
            'dark blue', 'olive drab', 'purple', 'red', 'dark cyan', \
            'yellow', 'orange', 'brown', 'pink']
    for i in range(17, 2, -1):
        tp.polygon(t, i, s, 'black', cols[17-i], True, True)
    tp.write(t, 'Regular\npolygons', 12, 'black', face='bold', vertc=True)


def writetest(t, scr):
    t.pd()
    t.pensize(4)
    t.pencolor('gray')
    x = scr.numinput('Turtle', 'Distance to move (0-500): ', 0, 0, 500)
    if x == 0:
        return
    t.lt(60)
    t.fd(x)
    td = round(t.distance(0,0), 3)
    th = round(t.heading(), 3)
    tx, ty = t.pos()
    tx, ty = round(tx, 3), round(ty, 3)
    a = str(td) + ', ' + str(th) + ', ' + str(tx) + ', ' + str(ty)
    #t.write(str(td) + ', ' + str(th) + ', ' + str(tx) + ', ' + str(ty))
    t.pu()
    t.fd(50)
    tp.write(t, a, 18, 'maroon', 'left', face='bold')
    t.bk(50)
        

if __name__ == '__main__':
    main()
