#!/usr/bin/env python

import turtle
import TurtleUtilsPMP as tp


def main():
    scr = tp.initializescreen()
    t1 = tp.initializeturtle()
    face(t1)
    scr.exitonclick()


def face(t):
    t.pensize(4)
    t.ht()
    skin(t)
    eyes(t)
    nose(t)
    mouth(t)
    ears(t)
    hair(t)


def skin(t):
    tp.sector(t, 300, 360, 'tan', 'tan', True, True)


def eyes(t):
    t.setpos(-100, 100)
    eye(t)
    t.setpos(100, 100)
    eye(t)


def eye(t):
    tp.sector(t, 70, 360, 'black', 'white', True, True)
    tp.sector(t, 50, 360, 'blue', 'blue', True, True)
    tp.sector(t, 30, 360, 'black', 'black', True, True)
    

def nose(t):
    t.setpos(0, -50)
    tp.sector(t, 50, 360, 'brown', 'brown', True, True)


def mouth(t):
    t.setpos(-100, -200)
    tp.rectangle(t, 30, 200, 'magenta', 'magenta', True)
    t.setpos(100, -200)
    t.lt(120)
    tp.segment(t, 200, 60, 'magenta', 'magenta', True)


def ears(t):
    t.seth(0)
    t.setpos(-280, 0)
    tp.sector(t, 100, 180, 'tan', 'tan', True, True, 'L')
    t.setpos(280, 0)
    tp.sector(t, 100, 180, 'tan', 'tan', True, True)


def hair(t):
    hair1(t, -240, 160, 1)
    hair1(t, 240, 160, -1)
    

def hair1(t, x, y, d):
    for i in range(13):
        tuft(t, x, y, x / 5, 'dark orange')
        x = x + 20 * d
        y = y + abs(x / 10)


def tuft(t, x, y, angle, colour):
    t.pencolor(colour)
    t.pu()
    tuft1(t, x, y, -40, angle, colour, 'L')
    t.rt(angle)
    t.fd(100)
    tuft1(t, x, y, 0, angle, colour, 'R')


def tuft1(t, x, y, k, angle, colour, lr):
    for i in range(5):
        t.setpos(x, y)
        t.seth(0)
        t.rt(angle + k)
        t.pd()
        tp.segment(t, 200, 30, colour, None, None, lr)
        t.pu()
        k = k + 10
    t.setpos(x, y)


if __name__ == '__main__':
    main()


'''
Main Python Turtle Commands

t.clear()       Clear screen
t.home()        Put turtle at screen centre pointing up
t.speed()       Set speed of turtle movement - has one parameter (0-10)
t.st()          Show turtle
t.ht()          Hide turtle (drawing is faster with turtle hidden)
t.setpos()      Set turtle position - has 2 parameters for x and y position
t.seth()        Set turtle heading - has 1 parameter (0-360)
t.fd()          Move forwards - has 1 parameter for distance
t.bk()          Move backward - has 1 parameter for distance
t.rt()          Turn right - has 1 parameter for number of degrees
t.lt()          Turn left  - has 1 parameter for number of degrees
t.circle()      Draw an arc - has 2 main parameters for radius and angle turned
t.pd()          Pen down
t.pu()          Pen up
t.pensize()     Pen width   - has 1 parameter for width
t.pencolor()    Pen colour  - has 1 constant or 3 RGB values as parameters
t.fillcolor()   Fill colour - has 1 constant or 3 RGB values as parameters
t.begin_fill()  Shapes drawn between this and t.end_fill are filled in
t.end_fill()    Ends filling in started by t.begin_fill
t.dot()         Put a dot at the current position
t.stamp()       Put a turtle at the current position and heading
t.write()       Writes text - details of text, alignment, font, etc. as parameters


Useful Colour Names

black, white, gray, light gray
red, dark red, maroon, salmon, pink
orange, dark orange, coral
yellow, gold, goldenrod
green, dark green, light green, olive drab
cyan, dark cyan, turquoise, aquamarine, sky blue
blue, dark blue, cornflower blue
purple, violet, magenta, orchid, slate blue
brown, sienna, chocolate, khaki, beige, tan


PMP Turtle Utils Commands

initializescreen(width=1000, height=850, colour='white', title='Turtle Graphics')
initializeturtle(shape='turtle', pen='black', fill='white')
write(turtle, text, fontsize=14, colour='black', align='center', font='Arial', face='normal')
gridxy(t, spacing=100, gridcolour='light gray', numbercolour='gray', numbered=True,
    startx=-500, starty=-500)
polygon(turtle, sides, size, pen='black', fill='white', filled=False, centred=False, lr='R')
square(turtle, size, pen='black', fill='white', filled=False, centred=False, lr='R')
rectangle(turtle, width, height, pen='black', fill='white', filled=False, centred=False,
    lr='R', oval=False)
oval(turtle, width, height, pen='black', fill='white', filled=False, centred=False, lr='R')
segment(turtle, radius, angle, pen='black', fill='white', filled=False, lr='R')
sector(turtle, radius, angle, pen='black', fill='white', filled=False, centred=True, lr='R')
circle(turtle, radius, pen='black', fill='white', filled=False, centred=True, lr='R')
ellipse(turtle, long radius, short radius, sides=20, pen='black', fill='white',
    filled=False, centred=False, lr='R', semi=False)
vesica(turtle, size [>=10], angle [30-159], pen='black', fill='white', filled=False) 
spiral(turtle, sides=4, size=100, gap=1, pen='black', lr='R')
star(turtle, points, size, pen='black', fill='white', filled=False, lr='R')
crescent(turtle, size [>=10], angle [30-120], pen='black', fill='white', filled=False, lr='R')

'''
