import turtle
import TurtleUtilsPMP as tp


def main():
    scr = tp.initializescreen()
    ada = tp.initializeturtle()
    setup(scr, ada)

    '''
    Enter your commands to move the turtle through the maze below this line.
    (The first two sections of the route are given to get you started.)
    '''
    ada.fd(92)
    ada.lt(90)
    ada.fd(170)
    ada.rt(90)
    

    '''
    Finish your commands to move the turtle through the maze above this line.
    '''
    
    scr.exitonclick()


def setup(s, t):
    s.bgpic('Maze 01 1000x850.gif')
    # Set a maze as the canvas background picture.
    t.turtlesize(1.5, 1.5, 2)
    # Set the turtle's width and length to 1.5x normal and outline thickness to 2x normal.
    t.pu()
    t.setpos(0, 350)
    t.pd()
    t.pencolor('red')
    t.write('MAZE', False, 'center', ('Arial', 36, 'bold'))
    t.pu()
    t.setpos(0, -385)
    t.pd()
    t.pencolor('green')
    t.write('Draw a line through the maze without touching any blue wall.', \
        False, 'center', ('Arial', 18, 'bold'))
    t.pu()
    t.setpos(-480, -85)  # Set the turtle starting position.
    t.seth(90)           # Set the turtle starting heading.
    t.pd()
    t.pencolor('red')
    t.pensize(8)
    t.speed(1)           # Draw at minimum speed.


if __name__ == '__main__':
    main()


'''
Main Python Turtle Commands

t.clear()       Clear screen
t.home()        Put turtle at screen centre pointing up
t.speed()       Set speed of turtle movement - has one parameter (0-10)
t.st()          Show turtle
t.ht()          Hide turtle (drawing is faster with turtle hidden)
t.setpos()      Set turtle position - has 2 parameters for x and y position
t.seth()        Set turtle heading - has 1 parameter (0-360)
t.fd()          Move forwards - has 1 parameter for distance
t.bk()          Move backward - has 1 parameter for distance
t.rt()          Turn right - has 1 parameter for number of degrees
t.lt()          Turn left  - has 1 parameter for number of degrees
t.circle()      Draw an arc - has 2 main parameters for radius and angle turned
t.pd()          Pen down
t.pu()          Pen up
t.pensize()     Pen width   - has 1 parameter for width
t.pencolor()    Pen colour  - has 1 constant or 3 RGB values as parameters
t.fillcolor()   Fill colour - has 1 constant or 3 RGB values as parameters
t.begin_fill()  Shapes drawn between this and t.end_fill are filled in
t.end_fill()    Ends filling in started by t.begin_fill
t.dot()         Put a dot at the current position
t.stamp()       Put a turtle at the current position and heading
t.write()       Writes text - details of text, alignment, font, etc. as parameters


Useful Colour Names

black, white, gray, light gray
red, dark red, maroon, salmon, pink
orange, dark orange, coral
yellow, gold, goldenrod
green, dark green, light green, olive drab
cyan, dark cyan, turquoise, aquamarine, sky blue
blue, dark blue, cornflower blue
purple, violet, magenta, orchid, slate blue
brown, sienna, chocolate, khaki, beige, tan


PMP Turtle Utils Commands

initializescreen(width=1000, height=850, colour='white', title='Turtle Graphics')
initializeturtle(shape='turtle', pen='black', fill='white')
write(turtle, text, fontsize=14, colour='black', align='center', font='Arial', face='normal')
gridxy(t, spacing=100, gridcolour='light gray', numbercolour='gray', numbered=True,
    startx=-500, starty=-500)
polygon(turtle, sides, size, pen='black', fill='white', filled=False, centred=False, lr='R')
square(turtle, size, pen='black', fill='white', filled=False, centred=False, lr='R')
rectangle(turtle, width, height, pen='black', fill='white', filled=False, centred=False,
    lr='R', oval=False)
oval(turtle, width, height, pen='black', fill='white', filled=False, centred=False, lr='R')
segment(turtle, radius, angle, pen='black', fill='white', filled=False, lr='R')
sector(turtle, radius, angle, pen='black', fill='white', filled=False, centred=True, lr='R')
circle(turtle, radius, pen='black', fill='white', filled=False, centred=True, lr='R')
ellipse(turtle, long radius, short radius, sides=20, pen='black', fill='white',
    filled=False, centred=False, lr='R', semi=False)
vesica(turtle, size [>=10], angle [30-159], pen='black', fill='white', filled=False) 
spiral(turtle, sides=4, size=100, gap=1, pen='black', lr='R')
star(turtle, points, size, pen='black', fill='white', filled=False, lr='R')
crescent(turtle, size [>=10], angle [30-120], pen='black', fill='white', filled=False, lr='R')

'''
