import turtle
import TurtleUtilsPMP as tp
import tkinter.messagebox as mb


def main():
    scr = tp.initializescreen(colour='black')
    ada = tp.initializeturtle()

    ada.home()
    ada.pd()
    ada.ht()
    squarespiral1(ada, 150, 2, 15, 2)
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next spiral.")
    ada.clear()
    ada.home()
    squarespiral2(ada, 150, 1.5, 7.5, 2)
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next spiral.")
    ada.clear()
    ada.home()
    squarespiral3(ada, 150, 0.75, 15, 2)
    #ada.st()

    scr.exitonclick()


def squarespiral1(t, size=150, increase=2, turn=10, pensz=1):
    colours = ['red', 'yellow', 'orange', 'green', 'cyan', 'sky blue', 'violet']
    t.pensize(pensz)
    for i in range(size):
        t.pencolor(colours[i % len(colours)])
        for j in range(4):
            t.fd(i * increase)
            t.rt(90)
        t.rt(turn)


def squarespiral2(t, size=150, increase=2, turn=10, pensz=1):
    colours = ['red', 'yellow', 'red', 'yellow']
    t.pensize(pensz)
    for i in range(size):
        for j in range(4):
            t.pencolor(colours[j])
            t.fd(i * increase)
            t.rt(90)
        t.rt(turn)


def squarespiral3(t, size=150, increase=2, turn=10, pensz=1):
    colours = ['red', 'yellow', 'sky blue', 'green']
    t.pensize(pensz)
    for i in range(size):
        t.fd(i * (i + increase) / size)  # For a tight spiral increase x size should be 100 to 125.
        for j in range(4):
            t.pencolor(colours[j])
            t.fd(i * increase)
            t.rt(90)
        t.rt(turn)



if __name__ == '__main__':
    main()
