import turtle
import TurtleUtilsPMP as tp
import TurtleCurvesPMP as tc
import tkinter.messagebox as mb


'''

Rhodonea is the original name for rose curve, a special type of hypotrochoid curve.
This program draws rose curves; these are produced mechanically by rolling a small circle inside
  the circumference of a larger circle with the pen offset from the centre of the small circle by
  more than its radius.

Parameters:
rhodonea(t, size=200, numerator=5, denominator=1, pen=['gray'], fill='white', filled=False, \
    centred=True, lr='R')
    
size is the radius of the circle containing the rose curve.
numerator and denominator are any integers.
  If the denominator is 1, the shape drawn is a 'flower' with 'petals'.
  If the numerator is greater than the denominator, this gives broader 'petals'.
  If the numerator is less than the denominator, this gives circle-based 'rose-window' shapes.
pen is a list of one or more colours which are repeated during drawing.

'''


def main():
    scr = tp.initializescreen(colour='black')
    ada = tp.initializeturtle()
    
    ada.st()
    colours = ['red', 'orange', 'yellow', 'light green', 'cyan', 'sky blue', 'violet']
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(18)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(1)
    tc.rhodonea(ada, 200, 5, 3, ['purple'], 'cornflower blue', True)
    scr.tracer(1)
    ada.ht()
    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next rose curve.")
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(18)
    ada.pd()
    ada.pensize(4)
    ada.st()
    scr.tracer(1)
    tc.rhodonea(ada, 200, 5, 1, colours, 'blue', False)
    scr.tracer(1)
    ada.ht()
    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next rose curve.")
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(270)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(2)
    tc.rhodonea(ada, 200, 4, 5, ['red', 'green', 'blue'], 'yellow', True)
    scr.tracer(1)
    ada.ht()
    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next rose curve.")
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(270)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(2)
    tc.rhodonea(ada, 200, 1, 8, ['red', 'red', 'yellow', 'yellow'], 'white', False)
    scr.tracer(1)
    ada.ht()
    ada.pu()

    scr.exitonclick()


if __name__ == '__main__':
    main()
