import turtle
import TurtleUtilsPMP as tp
import TurtleCurvesPMP as tc
import tkinter.messagebox as mb


'''

An Archimedean Spiral is a spiral with a constant gap between successive turns.

Parameters:
archimedeanspiral(t, turns=10, gap=1, step=10, pen=['black'], lr='R')

turns is the number of turns (or complete rotations) of the spiral.
gap is the constant distance between successive turns of the spiral.
step determines the accuracy of the drawing of the spiral, higher values being less accurate.

pen is a list of one or more colours which are repeated during drawing.

'''


def main():
    scr = tp.initializescreen(colour='black')
    ada = tp.initializeturtle()
    
    ada.st()
    colours = ['red', 'orange', 'yellow', 'light green', 'cyan', 'sky blue', 'violet']
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(0)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(2)
    tc.archimedeanspiral(ada, 18, 2/3, 10, colours)
    scr.tracer(1)
    ada.ht()
    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next Archimedean spiral.")
    ada.clear()
    ada.pu()
    ada.setpos(-150, 0)
    ada.seth(0)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(2)
    tc.archimedeanspiral(ada, 12, 1, 15, colours, 'L')
    ada.pu()
    ada.setpos(150, 0)
    ada.seth(0)
    ada.pd()
    tc.archimedeanspiral(ada, 12, 1, 15, colours)
    scr.tracer(1)
    ada.ht()

    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next Archimedean spiral.")
    ada.clear()
    ada.pu()
    ada.setpos(0, 0)
    ada.seth(0)
    ada.pd()
    ada.pensize(8)
    ada.st()
    scr.tracer(2)
    tc.archimedeanspiral(ada, 12, 1, 15, ['red', 'orange', 'yellow'])
    ada.pu()
    ada.setpos(0, 0)
    ada.seth(180)
    ada.pd()
    tc.archimedeanspiral(ada, 12, 1, 15, ['green', 'blue', 'cyan'])
    scr.tracer(1)
    ada.ht()

    ada.st()
    scr.exitonclick()


if __name__ == '__main__':
    main()
