import turtle
import TurtleUtilsPMP as tp
import TurtleCurvesPMP as tc
import tkinter.messagebox as mb


'''

A Logarithmic Spiral is a spiral with an increasing gap between successive turns.

Parameters:
logarithmicspiral(t, turns=10, gap=1, step=10, pen=['black'], lr='R')

turns is the number of turns (or complete rotations) of the spiral.
gap is a constant controlling the 'tightness' of the spiral, higher values being 'tighter'.
step determines the accuracy of the drawing of the spiral, higher values being less accurate.

pen is a list of one or more colours which are repeated during drawing.

'''


def main():
    scr = tp.initializescreen(colour='black')
    ada = tp.initializeturtle()
    
    ada.st()
    colours = ['red', 'orange', 'yellow', 'light green', 'cyan', 'sky blue', 'violet']
    ada.clear()
    ada.setpos(0, 0)
    ada.seth(0)
    ada.pd()
    ada.pensize(2)
    ada.st()
    scr.tracer(2)
    tc.logarithmicspiral(ada, 7, 1, 10, colours)
    scr.tracer(1)
    ada.ht()
    ada.pu()
    mb.showinfo('Turtle Graphics Demo', "Click 'OK' for the next logarithmic spiral.")
    ada.clear()
    ada.pu()
    ada.setpos(-150, 0)
    ada.seth(0)
    ada.pd()
    ada.pensize(2)
    ada.st()
    scr.tracer(2)
    tc.logarithmicspiral(ada, 12, 2, 15, ['green'], 'L')
    ada.pu()
    ada.setpos(150, 0)
    ada.seth(0)
    ada.pd()
    tc.logarithmicspiral(ada, 24, 4, 15, ['red', 'yellow', 'blue'])
    scr.tracer(1)
    ada.ht()

    ada.st()
    scr.exitonclick()


if __name__ == '__main__':
    main()
